package com.data.test.common;

import com.alibaba.druid.pool.DruidDataSource;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.controller.BaseController;
import lombok.extern.log4j.Log4j2;
import muyu.data.test.common.dataSoutce.DataSourceConfig;
import muyu.data.test.common.domain.Table;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.sql.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

@Log4j2
@RestController
@RequestMapping("/data")
public class TestController extends BaseController {
    /**
     * 随机字段
     * @param id
     * @return
     */
    @GetMapping("randomField")
    public Result randomField(Long id,String tableName) throws SQLException {
        System.out.println("id="+id);
        Connection connection = DataSourceConfig.getConnection(id);
        DruidDataSource verify = DataSourceConfig.verify(id);
        System.out.println(verify.getUrl());
        log.info("获取一个线程池:{}",connection);
        //运行sql语句
        Statement statement = connection.createStatement();
        ResultSet resultSet = statement.executeQuery("select * from " + tableName);
        //获取meteData
        ResultSetMetaData metaData = resultSet.getMetaData();
        //总数量
        int columnCount = metaData.getColumnCount();
        //随机数
        Random random = new Random();
        List<Table> list = new ArrayList<>();
        int i = random.nextInt(columnCount)+1;
        System.out.println("随机数"+i);
        while (resultSet.next()){
            for (int i1 = 1; i1 <= columnCount; i1++) {
                String s = metaData.getColumnName(i1);
                Object o = resultSet.getObject(i1);
                System.out.println(s);
                System.out.println(o);
                Table build = Table.builder()
                        .key(s)
                        .val(o)
                        .build();
                list.add(build);
            }
        }
        if (list.size()==0){
            return null;
        }
        int qu = list.size()/columnCount;
        System.out.println("区间数："+qu);
        int in = i*qu;
        System.out.println("字段长度"+columnCount);
        System.out.println("新数"+in);
        System.out.println(list);
        System.out.println("长度"+list.size());
        List<Table> tables = new ArrayList<>();
        for (int idd = i*columnCount-columnCount; idd < i*columnCount; idd++) {
            System.out.println(idd);
            tables.add(list.get(idd));
        }
        System.out.println(tables);
        DataSourceConfig.returnConnection(connection);
        return success(tables);
    }
}
